<template>
	<section class="tabs__content">
		<div class="layout-wrapper layout-wrapper--tiny">
			<header class="layout layout--middle palm-layout--stacked">
				<div class="layout__item">
					<h1 class="heading heading--main">Projects</h1>
					<p>
						Lorem ipsum dolor sit amet, consectetur adipisicing elit.
						Aspernatur aut commodi consectetur corporis cum eaque ex harum hic in ipsa labore nam odio omnis optio.
					</p>
				</div>
				<div class="layout__item">
					<div class="btn-wrapper btn-wrapper--center">
						<router-link to="/partecipate" class="btn btn--main">Participate</router-link>
					</div>
				</div>
			</header>
		</div>
		<gallery-grid v-bind:items="cars" v-bind:itemsPerPage="itemsPerPage" v-bind:activePage="activePage" v-on:pageChange="onPageChange">
    </gallery-grid>
    <p v-if="error">An error occurred while loading the gallery data.</p>
	</section>
</template>

<script>
import GalleryGrid from "@/components/GalleryGrid";

const ITEMS_PER_PAGE = 10;

export default {
  name: "Gallery",
  inject: ["carService"],
  components: {
    GalleryGrid: GalleryGrid
  },
  data: function() {
    return {
      cars: undefined,
      itemsPerPage: ITEMS_PER_PAGE,
      activePage: Number.parseInt(this.$route.params.page),
      error: undefined
    };
  },
  mounted: function() {
    this.carService.getAllCars().then(
      response => {
        this.cars = response.body;
      },
      errorResponse => {
        this.error = errorResponse.body;
      }
    );
  },
  watch: {
    '$route' (to, from) {
      this.activePage = Number.parseInt(to.params.page);
    }
  },
  methods: {
    onPageChange: function(page) {
      this.$router.push({ name: 'gallery', params: { page: page }})
    }
  }
};
</script>

